import { expressjwt } from "express-jwt";


import * as url from 'url';
const __dirname = url.fileURLToPath(new URL('.', import.meta.url));

//const sqlite3 = require('sqlite3');
import path from 'path';
const dbPath = path.resolve(__dirname, 'inventory.db');



// Verbindung zur Datenbank herstellen
/*let db = new sqlite3.Database(dbPath, (err) => {
    if (err) {
        console.error(err.message);
    }
    console.log('Connected to inventory database.');
});*/

function jwt() {
    console.log("jwt")
    const secret = "oRs2ciVCayoy5f64";
    return expressjwt({secret, algorithms: ["HS256"]}).unless({
        path: [
            // public routes that don't require authentication
            {url: "/api/*", methods: ['OPTIONS', "POST"]},
            {url: "/node/login/", methods: ['OPTIONS', "POST"]},
            {url: "/node/login/register", methods: ['OPTIONS', "POST"]},
            {url: "/images", methods: ['OPTIONS', "GET"]}, 
            {url: /\/index*/, methods: ['GET', 'OPTIONS']}, 
            //Alle GET von Routen, die nicht mit node anfangen erlauben
            {url: /^(?!\/node.*$).*/, methods: ['GET', 'OPTIONS']}, 
            "/"
        ],
        ext: [
            "png", "jpg", "css", "js", "ico", "ttf", "html", "map", "xlsx"
        ]
    });

}

async function isRevoked(req, payload, done) {
    console.log("isrevoked"); 
    console.log(payload); 
    return done(null, true);
    // check, ob es den username schon gibt
  /*  db.all("SELECT * FROM User WHERE id = (?)", [payload.payload.id], (err, users) => {
        if (err) {
            return done(null, true);
        }

        if (users.length === 0) {
            return done(null, true);
        }
        done();
    } );*/
    // revoke token if user no longer exists
};

export default jwt;